#!/bin/python
#average electric field
Eav=0;
#average electrostatic field 
Ee=0;
#average electric field due to only magnet
DeltaV=0;
#Delta V sum of Eav and self-field
DAa=0;
#average electric field due to only self-field
DAs=0;
#Accumulated Delta V
Accu_DeltaV=0;
#Accumulated Electrostatic field
Accu_Ee=0;
#Bmag radial in cylindrical coordinate in the center line of the tape
Bmagr_l=0;
#Bmag in z direction in cylindrical coordinate in the center line of the tape
Bmagz_l=1;

filein="Flux_Pump.txt"
filein2="Flux_Pump_Accu.txt"
filein3="Flux_Pump_Line.txt"
load "macros.plt"
load "style.plt"

###############################################################

if (Eav==1){
#set size ratio -1
@epsterm
ofile="Electric_Field.eps"
set out ofile
set terminal postscript enhanced 
set xlabel "Time"
set ylabel "E_{av}.l [mV]"
#set xrange [1/12.3:2/12.3]
#set xrange [0.113:0.131]
#set xrange [0.32:0.38]
#set ytics 0.02
set style data lines

plot \
filein using ($2):($3*1000) ls 1 notitle
@xterm
replot
pause -1 ofile
reset
}
################################################################
if (Ee==1){
#set size ratio -1
@epsterm
ofile="Electrostatic_Field.eps"
set out ofile
set terminal postscript enhanced 
set xlabel "Time"
set ylabel "Electrostatic Field.l [mV]"
#set xrange [1/4.25:2/4.25]
set xrange [0.11:0.131]
set style data lines
set grid
plot \
filein using ($2):($4*1000/12.3) ls 1 notitle
@xterm
replot
pause -1 ofile
reset
}
################################################################
if (DeltaV==1){
#set size ratio -1
@epsterm
ofile="DeltaV.eps"
set out ofile
set terminal postscript enhanced 
set xlabel "Time"
set ylabel "{/Symbol D}V [mV]"
#set xrange [1/4.25:2/4.25]
#set xrange [0.32:0.38]
#set xrange [1/12.3:2/12.3]
set xrange [0.11:0.131]
set style data lines
#set ytics 0.01
set grid
plot \
filein using ($2):($5*1000/12.3) ls 1 notitle
@xterm
replot
pause -1 ofile
reset
}
################################################################
if (DAa==1){
#set size ratio -1
@epsterm
ofile="DAa.eps"
set out ofile
set terminal postscript enhanced 
set xlabel "Time"
set ylabel "E of magnet.l [mV]"
#set xrange [1:2]
set style data lines

plot \
filein using ($2):($6*1000) ls 1 notitle
@xterm
replot
pause -1 ofile
reset
}
################################################################
if (DAs==1){
#set size ratio -1
@epsterm
ofile="DAs.eps"
set out ofile
set terminal postscript enhanced 
set xlabel "Time"
set ylabel "E of self-field.l [mV]"
#set xrange [1:2]
#set xrange [1/4.25:2/4.25]
set style data lines

plot \
filein using ($2):($7*1000) ls 1 notitle
@xterm
replot
pause -1 ofile
reset
}
##################################################################
if (Accu_DeltaV==1){
#set size ratio -1
@epsterm
ofile="Accu_DeltaV.eps"
set out ofile
set terminal postscript enhanced 
set xlabel "Time [s]"
set ylabel "Cumulative Time Average   {/Symbol D}V [{/Symbol m}V]"
#set xrange [0:10/4.25]
#set xrange [0.113:0.131]
set xtics 0.5
set style data lines

plot \
filein2 using ($2):($4*1000000) ls 1 notitle
@xterm
replot
pause -1 ofile
reset
}
#######################################################################
if (Accu_Ee==1){
#set size ratio -1
@epsterm
ofile="Accu_Ee.eps"
set out ofile
set terminal postscript enhanced 
set xlabel "Time [s]"
set ylabel "{/Symbol f} [{/Symbol m}V]"
#set ylabel "{/Symbol f} [{/Symbol m}V.s]"
#set xrange [1/12.3:2/12.3]
#set xrange [0.113:0.131]
#set xtics 1
set style data lines

plot \
filein2 using ($2):($3*1000000) ls 1 notitle
@xterm
replot
pause -1 ofile
reset
}
########################################################################
if (Bmagr_l==1){
#set size ratio -1
@epsterm
ofile="Bmagr_l.eps"
set out ofile
set terminal postscript enhanced 
set xlabel "Tape Width [mm]"
set ylabel "Br [mT]"
#set xrange [1/12.3:2/12.3]
#set xrange [0.113:0.131]
#set xrange [0.32:0.38]
#set xtics 4
#set ytics 20
set grid
set style data lines

plot \
filein3 using ($2*1000):($3*1000) ls 1 notitle
@xterm
replot
pause -1 ofile
reset
}
###########################################################################
if (Bmagz_l==1){
set size ratio -1
set size square
@epsterm
filebase="Bmag_l"
load "style.plt"
set palette rgbformulae 30,31,32
set key off
set samples 100; set isosamples 100
lwidth=1
set grid
set samples 200
#set autoscale
nts=360;    #number of time steps
#set xrange [0:x*1000]
set yrange [-300:100]

do for [i=0:nts]{
set terminal jpeg
set xlabel "Position [mm]"
set ylabel "Bmag_l [mT]"
ofile=sprintf("%s_%03d.jpeg",filebase,i) ; set out ofile
plot filein3 index i using ($2*1000):($4*1000) ls 2 notitle
}
@xterm
replot
pause -1 sprintf("Output at %s",ofile)
reset
}
########################################################################
